/*
 * cat.c
 * concatenate files to stdout
 * Ver 0.5
*/

#include <stdio.h>

void filecopy(FILE *fp)	/* copy file fp to standard output */
{
    int c;

    while ((c = getc(fp)) != EOF)
	putc(c, stdout);
}

int main(int argc, char *argv[])
{
    FILE *fp, *fopen();

    if (argc == 1) /* no args; copy from standard input */
	 filecopy(stdin);
    else
	 while (--argc > 0)
	    if ((fp = fopen(*++argv, "r")) == NULL)
	    {
		fprintf(stderr, "cat: can't open %s\n", *argv);
		exit(1);
	    }
	    else
	    {
		filecopy(fp);
		fclose(fp);
	    }
    exit(0);
}

