/*
	cp.c:
	copy file1 [filen] destination
	Ver. 0.5
	exit status = 0 OK
		    > 0 Error(s).
	-f Don't prompt for confirmation if destianation path exists.
	-i Prompt for confirmation if destiation path exists.
TO DO
	-R Recorsive copy.
*/

#include <stdio.h>
#include "bcom.h"
#define MAX_LEN	256

extern int errno;
char *prog="cp";
int opf=1;
int opi=0;
char overWrite='y';
char filler[MAX_LEN];

void usage()
{
	fprintf(stderr,"usage: %s [-fi] name1 [name2 ... nameN] target\n",
		prog);
	exit(1);
}

int cpFile(char *s1, char *s2)
{
	FILE *fi, *fo;
	char s3[MAX_LEN];
	int state=0, c;
	int x=0;

	for(x=strlen(s1); x>0 && s1[x]!='/'; x--)
		;
	if (s1[x] == '/')
		++x;

	if (ftype(s2) == 'd')
		sprintf(s3,"%s/%s", s2, s1+x);
	else
		strcpy(s3, s2);

	if (fino(s1)==fino(s3))
	{
		printf("%s: %s and %s are the same file; cannot copy\n",
			prog, s1, s3);
		return(1);
	}

	if (fi=fopen(s1, "rb"))
	{
		if (opi && ftype(s3)!='n')
		{
			overWrite='x';
			while (overWrite!='y' && overWrite!='n')
			{
				printf("%s: overwrite %s? (y/n) ",
					prog, s3);
				overWrite=getc(stdin);
				gets(filler);
				fflush(stdin);
			}
			if (overWrite='n')
			{
				fclose(fi);
				return 1;
			}
		}
		if (fo=fopen(s3, "wb"))
		{
			while ((c=fgetc(fi)) != EOF)
			{
				fputc(c, fo);
			}
			fclose(fo);
		}
		else
		{
			printf("%s: error %d writing %s\n", prog, errno, s3);
			state=1;
		}
		fclose(fi);
	}
	else
	{
		printf("%s: error %d reading %s\n", prog, errno, s1);
		state=1;
	}
	return(state);
}

int main(int argc, char *argv[])
{
	int i;
	char infile[MAX_LEN];
	char outfile[MAX_LEN];
	int status=0;
	char opt[32];
	int wOpt=0;

	if (argc < 3)
		usage();

	/* options check */
	strcpy(opt, argv[1]);
	if (opt[0]=='-')
	{
		wOpt=1;
		for (i=1; i<strlen(opt); i++)
		{
			switch (opt[i])
			{
				case 'i':
					opi=1;
					opf=0;
					break;
				case 'f':
					opf=1;
					opi=0;
					break;
				default:
					usage();
			}
		}
		if (argc < 3+wOpt)
			usage();
	}

	strcpy(outfile, argv[argc-1]);
	if (argc>3+wOpt && ftype(outfile)!='d')
	{
		printf("%s: For more than 2 args, last must be a dir\n");
		return 1;
	}

	for (i=(1+wOpt); i<(argc-1); i++)
	{
		strcpy(infile, argv[i]);
		/* printf("copy %s %s\n", infile, outfile); */
		status = status + cpFile(infile, outfile);
	}

	return(status);
}
