/*
	ln.c:
	link file1 [filen] destination
	Ver. 0.5
TODO
	-f Force existing destination pathnames to be removed to allow the link.
	-s Create symbolic links instead of hard links.

	Exit status:
		0	All the specified files were linked successfully.
		>0	An error occurred.
*/

#include <stdio.h>
#include "bcom.h"
#define MAX_LEN	256

extern int errno;
char *prog="ln";

int main(int argc, char *argv[])
{
	int i;
	char infile[MAX_LEN];
	char outfile[MAX_LEN];
	int status=0, tmp_status=0;

	if (argc < 3)
	{
		printf("usage: %s source-1 [source-n] destination\n", prog);
		return(1);
	}
	strcpy(outfile, argv[argc-1]);
	if (argc>3 && ftype(outfile)!='d')
	{
		printf("%s: For more than 2 args, last must be a dir\n");
		return(1);
	}

	for (i=1; i<(argc-1); i++)
	{
		strcpy(infile, argv[i]);
		/* printf("link %s %s\n", infile, outfile); */
		tmp_status = link(infile, outfile);
		if (tmp_status == -1)
		{
			++status;
			printf("%s: error %d linking %s to %s\n", prog,
				errno, infile, outfile);
		}
	}

	return(status);
}
