/*
	rm.c
	remove files
	Ver. 0.5
	-f	Do not prompt for confirmation. Do not write diagnostic
      	 	messages or modify the exit status in the case of nonexistent
	       	operands. Any previous occurrences of the -i option shall be
	       	ignored.
	-i	Prompt for confirmation as described previously. Any previous
       		occurrences of the -f option shall be ignored.
TODO
	-R	Remove file hierarchies.
	-r	Equivalent to -R.
	Exit status:
		0	All of the named directory entries for which rm
	       		performed actions equivalent to the rmdir() or
		       	unlink() functions were removed.
		>0	An error occurred.
*/

#include <stdio.h>

#define MAX_LEN	256

char *prog="rm";

void usage()
{
	printf("usage: %s [-i]|[-f] name1 [name2 ... nameN]\n", prog);
	exit(1);
}

int main(int argc, char *argv[])
{
	int i, y=1;
	int status=0;
	int interactive=0;
	char nome[MAX_LEN];
	char opt[32];
	char toDelete='y';
	char filler[MAX_LEN];

	if (argc < 2)
		usage();

	strcpy(opt, argv[1]);

	if (opt[0] == '-')
	{
		if (argc < 3)
			usage();
		y = 2;
		switch (opt[1])
		{
		case 'i':
			interactive=1;
			toDelete='x';
			break;
		case 'f':
			interactive=0;
			toDelete='y';
			break;
		default:
			usage();
		}
	}
	else
	{
		y = 1;
		interactive=1;
		toDelete='x';
	}

	for (i=y; i < argc; ++i)
	{
		strcpy(nome, argv[i]);

		if (interactive == 1)
		{
			while (toDelete!='y' && toDelete!='n')
			{
				printf("delete %s? (y/n) ", nome);
				toDelete=getc(stdin);
				fgets(filler, MAX_LEN, stdin);
				fflush(stdin);
			}
		}

		if (toDelete == 'y')
		{
			if (unlink(nome))
			{
				printf("rm: can't delete %s.\n", nome);
				status=-1;
			}
			else
			{
				printf("rm: %s deleted.\n", nome);
			}
		}
		if (interactive == 1)
			toDelete='x';
	}
	return(status);
}
