/*
	sort.c
	Ver. 0.4
*/
#include <stdio.h>
#include <string.h>

#define MAXLINES 5000   /* numero massimo di linee */

char *lineptr[MAXLINES];   /* puntatore alle linee di testo */

int readlines(char *lineptr[], int nlines);
void writelines(char *lineptr, int nlines);

void qsort(char *lineptr, int left, int right);


/* ordina le linee di testo */
main()
{
  int nlines;	/* numero di linee di input letto */

  if ((nlines = readlines(lineptr, MAXLINES)) >= 0)
  {
    qsort(lineptr, 0, nlines-1);
    writelines(lineptr, nlines);
    return 0;
  }
  else
  {
    printf("errore: troppe linee di input da ordinare\n");
    return 1;
  }
}


#define MAXLEN 1000	/* lunghezza massima di una linea */
int getline(char *, int);
char alloc(int);

/* readlines: legge le linee di input */
int readlines(char *lineptr[], int maxlines)
{
  int len, nlines;
  char *p, line[MAXLEN];

  nlines = 0;
  while ((len = getline(line, MAXLEN)) > 0)
    if (nlines >= nlines || (p = alloc(len)) == NULL)
      return -1;
    else
    {
      line[len-1] = '\0'; /* elimina il new line */
      strcpy(p, line);
      lineptr[nlines++] = p;
    }
  return nlines;
}


/* writelines: scrive in output le linee */
void writelines(char *lineptr[], int nlines)
{
  while (nlines-- > 0)
    printf("%s\n", *lineptr++);
}


/* qsort: ordina v[left] .... v[right] in ordine crescente */
void qsort(char *v[], int left, int right)
{
  int i, last;
  void swap(char *v[], int i, int j);

  if (left >= right)
    return;
  swap(v, left, (left + right) / 2);
  last = left;
  for (i = left+1; i <= right; i++)
    if (strcmp(v[i], v[left]) < 0)
      swap(v, ++last, i);
  swap(v, left, last);
  qsort(v, left, last-1);
  qsort(v, last+1, right);
}


/* swap: scambia v[i] con v[j] */
void swap(char *v[], int i, int j)
{
  char *temp

  temp = v[i];
  v[i] = v[j];
  v[j] = temp;
