/*
	tail.c
	Print last n lines of input
	Ver. 0.5
TODO
	Argument input-file
	-c number of byte
	-f waiting from input source
EXIT STATUS
	0 Successfull.
	>0 An error occurred.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define DEFLINES 10
#define LINES 100
#define MAXLEN 100

char *prog="tail";

void error(char *fmt, char *prm)
{
	printf(fmt, prm);
	exit(1);
}

int main(int argc, char *argv[])
{
	char *p;
	char *buf;
	char *bufend;
	char line[MAXLEN];
	char *lineptr[LINES];
	int first, i, last, len, n, nlines;

	if (argc == 1)
		n = DEFLINES;
	else if (argc == 2 && (*++argv)[0] == '-')
		n = atoi(argv[0]+1);
	else
		error("usage: %s [-n]\n", prog);
	if (n<1 || n>LINES)
		n=LINES;

	for (i=0; i<LINES; i++)
		lineptr[i]=NULL;
	if ((p=buf=malloc(LINES*MAXLEN)) == NULL)
		error("%s: cannot allocate buf\n", prog);
	bufend=buf+LINES*MAXLEN;
	last=0;
	nlines=0;
	while ((len=strlen(fgets(line,MAXLEN,stdin))) > 0)
	{
		if (p+len+1 >= bufend)
			p=buf;
		lineptr[last]=p;
		strcpy(lineptr[last], line);
		if (++last >= LINES)
			last=0;
		p+=len+1;
		++nlines;
	}
	if (n>nlines)
		n=nlines;
	first=last-n;
	if (first<0)
		first+=LINES;
	for (i=first; n-- > 0; i=(i+1) % LINES)
		printf("%s", lineptr[i]);
	return 0;
}

