/*
	wc.c
	count lines,word,characters
	Ver. 0.5
TODO
	-c	Write to standard output the number of bytes in each input file.
	-m	Write to standard output the number of chars in each input file.
	-l	Write to standard output the number of \n in each input file.
	-w	Write to standard output the number of words in each input file.
EXIT STATUS
	0	Successful completion.
	>0	An error occurred.
*/

#include <stdio.h>

int main(argc, argv)
int argc;
char *argv[];
{
  int c,i,inword;
  FILE *fp, *fopen();
  long linect, wordct, charct;
  long tlinect = 0, twordct = 0, tcharct = 0;

  i = 1;
  fp = stdin;
  do
  {
    if (argc>1 && (fp=fopen(argv[i],"r")) == NULL)
    {
      fprintf(stderr,"wc: non posso aprire %s\n", argv[i]);
      continue;
    }
    linect = wordct = charct = inword = 0;
    while ((c = getc(fp)) != EOF) {
      charct++;
      if (c == '\n')
        linect++;
      if (c == ' ' || c == '\t' || c == '\n')
        inword = 0;
      else if (inword == 0) {
        inword = 1;
        wordct++;
      }
    }
    printf("%7ld %7ld %7ld",linect, wordct, charct);
    if (argc > 1)
      printf(" %s\n", argv[i]);
    fclose(fp);
    tlinect += linect;
    twordct += wordct;
    tcharct += charct;
  } while (++i < argc);
  if (argc > 2)
    printf("%7ld %7ld %7ld totale\n", tlinect, twordct, tcharct);
  exit(0);
}

